<?
   require('data.inc');
   require('util.inc');

   define("PREFIX",    "data");
   define("FIVE_HTML", "five.html");

   function recordCompare($a, $b)
   {
      return($a[0] <= $b[0]);
   }

   // -------------------------------------
   // Script Begins Here
   // -------------------------------------

   ini_set("memory_limit", "2000M");

   if(($handle = @opendir(PREFIX)) == false)
      die("Could not open: " . PREFIX . "\n");

   $movieToScores = array();

   while(($entry = readdir($handle)) !== false)
   {
      if($entry == "." || $entry == "..")
         continue;

      $path = PREFIX . "/" . $entry;

      if(($f = fopen($path, "r")) == false)
         die("Could not open: $$path\n");

      while(($line = fgets($f)) !== false)
      {
         $parts = explode(",", trim($line));

         if(!isset($movieToScores[$parts[0]]))
            $movieToScores[$parts[0]] = array();

         $movieToScores[$parts[0]][] = $parts[1];
      }

      fclose($f);
   }

   closedir($handle);

   if(!Data::getMovieEntries(DATA_MOVIE_TITLES_PATH, $entries, $errMsg))
      die($errMsg);

   $records = array();

   foreach($movieToScores as $movie => $scores)
   {
      $n = count($scores);

      if($n >= 500)
      {
         $sum = 0;

         foreach($scores as $score)
            $sum += $score;

         $avg = $sum / (double)$n;
         $title = "";
         $year  = "";

         foreach($entries as $entry)
         {
            if($entry->mID == $movie)
            {
               $title = $entry->mTitle;
               $year  = $entry->mYear;
               break;
            }
         }

         $records[] = array(sprintf("%.2f", $avg), $year, $title);
      }
   }

   usort($records, "recordCompare");

   $headers = array("Rating", "Year", "Title");

   $content =
      "  <h3><u>Top 20 Titles</u></h3>\n" .
      "  <blockquote>\n" .
      Util::makeTable($headers, array_slice($records, 0, 20), "   ") . "\n" .
      "  </blockquote>\n";

   $first = true;

   for($i = 1930; $i <= 2000; $i += 10)
   {
      $list = array();

      foreach($records as $record)
      {
         $value = (int)($record[1] / 10) * 10;

         if($value == $i)
         {
            $list[] = $record;

            if(count($list) == 5)
               break;
         }
      }

      if($first) $first = false;
      else       $content .= "\n";

      $content .=
         "  <h3><u>Top 5 Titles, Decade: $i</u></h3>\n" .
         "  <blockquote>\n" .
         Util::makeTable($headers, $list, "   ") . "\n" .
         "  </blockquote>";
   }

   if(($f = @fopen(FIVE_HTML, "w")) == false)
      die("Could not open: " . FIVE_HTML . "\n");

   fprintf($f, "%s\n", Util::makeHTML("Top Titles", $content));

   fclose($f);

   print("Successfully wrote: " . FIVE_HTML . "\n");

?>
